unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls;


type
  TForm1 = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    GroupBox1: TGroupBox;
    ProgressBar1: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  protected
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  WH_MOUSE_LL = 14;

type
  PtagMSLLHookStruct = ^tagMSLLHOOKSTRUCT;
  tagMSLLHOOKSTRUCT = packed record
    pt: TPoint;
    mouseData: DWORD;
    flags: DWORD;
    time: DWORD;
    dwExtraInfo: Cardinal;
  end;

var
  llMouseHook: HHOOK = 0;
  wTaskBar: THandle;

function IsMouseOverTaskbar(pt: TPoint): Boolean;
var
  Rect: TRect;
begin
  Result := False;
  if wTaskbar = 0 then
    Exit;
  if not IsWindowVisible(wTaskbar) then
    Exit;
  GetWindowRect(wTaskBar, Rect);
  Result := PtInRect(Rect, pt);
end;

function LowLevelMouseHook(nCode: Integer; wParam: WPARAM; lParam: LPARAM): HRESULT; stdcall;
var
  pmsll: PtagMSLLHookStruct;
  pt: TPOINT;
begin
  pmsll := PtagMSLLHookStruct(Pointer(lParam));
  if nCode = HC_ACTION then
  begin
    if wParam = WM_LBUTTONUP then
    begin
      pt := pmsll^.pt;
      if IsMouseOverTaskbar(pt) then
       begin
         Form1.Caption := 'Taskbar clicked - invalidating groupbox';
         Form1.GroupBox1.Invalidate;
       end
       else
         Form1.Caption := 'Clicked outside the taskbar';
    end;
  end;
  Result := CallNextHookEx(llMouseHook, nCode, wParam, lParam);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  llMouseHook := 0;
  llMouseHook := SetWindowsHookEx(WH_MOUSE_LL, @LowLevelMouseHook, HInstance, 0);
  if llMouseHook <> 0 then
    wTaskbar := FindWindow('Shell_TrayWnd', nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if (llMouseHook <> 0) and UnhookWindowsHookEx(llMouseHook) then
    llMouseHook := 0;
end;

end.

